const http = require('http');
const sandbox = require('./sandbox.js')
// const Future = require('fibers/future')

console.log('http-worker.js - starting worker: ' , process.pid );

var asyncNonsense = function( callback ){
  // var fut = new Future()

  setTimeout(function () {
    callback()
  }, 500);

  // return fut.wait()
}

try{
  var server = http.createServer(function(req, response ) {
    //send the process id for timeout function
    process.send(process.pid)

    var body = '';
    req.on('data', function (data) {
      // console.log('http-worker.js - request buffer received ', data)
      body += data;
    });

    req.on('end', function () {
      // console.log("http-worker - request - Body: ", body);
      try{
        var scriptObj = JSON.parse( body )
        console.log( 'http-worker - request -  scriptObj', scriptObj )

        asyncNonsense( function(err, res ){
          response.writeHead( 200, { 'Content-Type': 'application/json'});
          response.write( '{ "result" : "hello" }'  )
          response.end()
        })

        sandbox( scriptObj.script , scriptObj.libs , scriptObj.context, function(err, res ){
          console.log("http-worker - sandbox err", err)
          console.log("http-worker - sandbox res", res)

          //ask master to clear the master timeout, so the process doesn't end
          // process.send( "clearTimeout");
          //
          // if ( err ){
          //   response.writeHead( 500, { 'Content-Type': 'application/json'});
          // }else{
          //   response.writeHead( 200, { 'Content-Type': 'application/json'});
          // }
          //
          // var output = res || err
          // response.write( JSON.stringify( output ) ); // errors were not being reported
          // response.writeHead( 200, { 'Content-Type': 'application/json'});
          // response.write( '{ "result" : "hello" }'  )
          // response.end()
        });
      }catch(e){
        console.log('http-worker.js - sandbox - error', e );
      }
    });
  });
}catch( err ){
  console.log('http-worker.js - request - error', err );
}

server.listen(8000);

server.on('clientError', (err, socket) => {
  console.log('http-worker.js - clientError - bad request', err);
  // socket.end('HTTP/1.1 400 Bad Request\r\n\r\n');
});

server.on('error', (err, socket) => {
  console.log('http-worker.js -  error - unknown', err);
  // socket.end('HTTP/1.1 400 Bad Request\r\n\r\n');
});

process.on('uncaughtException', function(err) {
  console.log("http-worker.js - uncaughtException", err.stack);
  // console.error(err.stack);
  process.exit();
});

// server.on('request', function (data) {
//   console.log('http-worker.js - request message  ', data)
// });


server.on('listening', function(){
  // console.log('http-worker.js - server listening ')
  process.send( 'ready' );
});
